"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
/**
 * mocks an object's property
 */
function default_1(object, path, value) {
    if (object === undefined || path === undefined)
        throw new Error('should not be undefined');
    return {
        run(ctx) {
            ctx.stubs = ctx.stubs || [];
            ctx.stubs.push(_.get(object, path));
            _.set(object, path, value);
        },
        finally(ctx) {
            const stub = ctx.stubs.pop();
            _.set(object, path, stub);
        },
    };
}
exports.default = default_1;
